#!/usr/bin/perl -w
# 
# sb::Plugin::BlogToolSupport - Module for sb
# == written by Assy <info@aizack.net> ===
# == Copyright (C) 2009 AIZACK.NET  ==

# 0.01 [2006/02/09] Debut.
# 0.02 [2006/03/05] Googley[WÑXNvgsȏۑł悤ɎdlύX 
#					Googley[WN̓Ǝ^OύX {bts_pagerankon}  {bts_pagerank} 
#
# 0.03 [2006/09/23] trackfeed̃XNvg1sȏۑł悤ɎdlύX
#					ݒۑAč\z𑣂bZ[Wo悤ɎdlύX
#
# 0.04 [2006/10/11] eƎ^OύXiړbts_폜j
#					BlogPetveenaA[eBXg\̓Ǝ^O̒ǉ
#					Ǘʂł̃ANZXL[ԈĂ̂C
#					Ǘʂ̃C^[tF[XV
#
# 0.05 [2009/03/22]
#					veenaA[eBXg\̓Ǝ^O̔p~
#					ɂłgg^Op{bts_extend1} {bts_extend2} {bts_extend3} ̂Rǉ
#					Ǘʂ̃C^[tF[X
#
# 0.05a[2010/11/14]
#					g^O3SgȂԔȃoOCB
package sb::Plugin::BlogToolSupport;

#
# initialize plugin
#
use sb::Plugin ();

# register plugin
sb::Plugin->register_plugin(
	'lang' => {
		'ja' => 'euc',
		'en' => 'ascii',
	},
	'text' => {
		'type'    => 'admin, cms',
		'name'    => 'BlogTool Support',
		'text'    => 'BlogTool Insert Support',
		'author'  => 'Assy',
		'detail'  => 'http://lab.aizack.net',
		'version' => '0.05a',
		'publish' => 'yes',	# vOCXĝ߂̊giJ/Jj
	},
	'file' => 'blogtoolsupport.txt',
	'data' => 1,
);

# register as admin plugin
sb::Plugin->register_admin_module(
	'mode'   => 'blogtoolsupport',
	'level'  => 1,
	'module' => 'sb::Admin::BlogToolSupport',
);

# register as cms plugin
sb::Plugin->register_content_module(
	'type'	   => 'main',
	'callback' => \&sb::Content::BlogToolSupport::_insert_script,
	'field'    => 'blogtool',
);

package sb::Content::BlogToolSupport;

use sb::Config ();

sub _insert_script {
	my $cms = shift;
	my $conf  = sb::Config->get;

	$cms->num(0);
	my $tfeed = $conf->value('conf_blogtool_trackfeed');
	$cms->tag('trackfeed' => $tfeed);
	my $fmeter = $conf->value('conf_blogtool_feedmeter');
	$cms->tag('feedmeter' => $fmeter);
	my $prank = $conf->value('conf_blogtool_pagerank');
	$cms->tag('pagerank' => $prank);
	my $tword = $conf->value('conf_blogtool_trackword');
	$cms->tag('trackword' => $tword);
	my $ninja = $conf->value('conf_blogtool_ninjaaccess');
	$cms->tag('ninja_access' => $ninja);
	my $ganalytics = $conf->value('conf_blogtool_googleanalytics');
	$cms->tag('google_analytics' => $ganalytics);
	my $blogpet = $conf->value('conf_blogtool_blogpet');
	$cms->tag('blogpet' => $blogpet);
	my $extend1 = $conf->value('conf_blogtool_extend1');
	$cms->tag('bts_extend1' => $extend1);
	my $extend2 = $conf->value('conf_blogtool_extend2');
	$cms->tag('bts_extend2' => $extend2);
	my $extend3 = $conf->value('conf_blogtool_extend3');
	$cms->tag('bts_extend3' => $extend3);
	return (1);
}

package sb::Admin::BlogToolSupport;

use vars qw( @ISA );
use sb::Interface ();
use sb::Config ();
use sb::TemplateManager ();
@ISA = qw( sb::App::Admin );

# constant value
sub TEMPLATE  (){ 'blogtoolsupport.html' };

# callback function
sub callback {
	my $self = shift;
	return ( $self->{'regi'} ) 
		? $self->_save_setting(@_)
		: $self->_open_ui(@_);
}

# save setting
sub _save_setting {
	my $self = shift;
	my $cgi  = sb::Interface->get;
	my $conf  = sb::Config->get;

	# get query
	$conf->value('conf_blogtool_trackfeed' => $cgi->value('tfeed'));
	$conf->value('conf_blogtool_feedmeter' => $cgi->value('fmeter'));
	$conf->value('conf_blogtool_pagerank' => $cgi->value('prank'));
	$conf->value('conf_blogtool_trackword' => $cgi->value('tword'));
	$conf->value('conf_blogtool_ninjaaccess' => $cgi->value('ninja'));
	$conf->value('conf_blogtool_googleanalytics' => $cgi->value('ganalytics'));
	$conf->value('conf_blogtool_blogpet' => $cgi->value('blogpet'));
	$conf->value('conf_blogtool_extend1' => $cgi->value('extend1'));
	$conf->value('conf_blogtool_extend2' => $cgi->value('extend2'));
	$conf->value('conf_blogtool_extend3' => $cgi->value('extend3'));
	# save data
	$conf->store;

	# ۑbZ[W̕\
	my $lang = sb::Language->get;
	my $msg = $lang->string('parts_confcomp');
	$msg .= $lang->string('parts_rec_make');
	$msg .= sprintf($lang->string('parts_link_bld'),&sb::App::Admin::get_script_path);
	return $self->_open_ui('message'=>$msg);
}

# open ui
sub _open_ui {
	my $self = shift;
	my %param = ('message' => '', @_);
	my $cms  = sb::TemplateManager->new(sb::Plugin->load_template('file' => TEMPLATE));
	my $conf  = sb::Config->get;

	# set tag value
	$cms->num(0);
	my $tfeed = $conf->value('conf_blogtool_trackfeed');
	$cms->tag('trackfeed' => sb::Text->entitize($tfeed));
	my $fmeter = $conf->value('conf_blogtool_feedmeter');
	$cms->tag('feedmeter' => sb::Text->entitize($fmeter));
	my $prank = $conf->value('conf_blogtool_pagerank');
	$cms->tag('pagerank' => sb::Text->entitize($prank));
	my $tword = $conf->value('conf_blogtool_trackword');
	$cms->tag('trackword' => sb::Text->entitize($tword));
	my $ninja = $conf->value('conf_blogtool_ninjaaccess');
	$cms->tag('ninja_access' => sb::Text->entitize($ninja));
	my $ganalytics = $conf->value('conf_blogtool_googleanalytics');
	$cms->tag('google_analytics' => sb::Text->entitize($ganalytics));
	my $blogpet = $conf->value('conf_blogtool_blogpet');
	$cms->tag('blogpet' => sb::Text->entitize($blogpet));
	my $extend1 = $conf->value('conf_blogtool_extend1');
	$cms->tag('bts_extend1' => sb::Text->entitize($extend1));
	my $extend2 = $conf->value('conf_blogtool_extend2');
	$cms->tag('bts_extend2' => sb::Text->entitize($extend2));
	my $extend3 = $conf->value('conf_blogtool_extend3');
	$cms->tag('bts_extend3' => sb::Text->entitize($extend3));

	# display massage if requested
	if ($param{'message'} ne '') {
		$cms->num(0);
		$cms->tag('sb_process_message' => $param{'message'});
		$cms->block('sb_process_message' => 1);
	}

	# display administration user interface
	return sb::Interface->get->head('type'=>'text/html') . $self->set_main($cms->output);
}

1;
__END__
